/*

Even though we have a lot of memory available to us on SQL Server,
we don't have unlimited memory. SQL Server caches data in memory
as much as it can. When it can't store data in memory, it either
flushes it to disk for permanent storage (in a table), or it may
swap over to TempDB, a database that sits on faster disk and
acts like a swap file.

TempDB has been described as the public toilet of SQL Server.
Many different things make use of TempDB, and you get one per
instance for everything to use. This can lead to contention
as multiple objects use TempDB, and can in turn lead to poor
performance or even query failure (it's possible to blow TempDB
with a badly written query or too much data.)


*/